(function() {
  var firstLoad = true;
  var originW = "originW";
  var NE_CLS_CH_TOP = "NE-CH-TOP";
  var needCheckQuote = true;
  var reformator = new ReformattingCore();
  var imgsMap = {};

  function queryAll(doc, selector) {
    return (doc || document.documentElement).querySelectorAll(selector);
  }

  function query(doc, selector) {
    return (doc || document.documentElement).querySelector(selector);
  }

  function attr(el, name, value) {
    if (!!value) {
      el.setAttribute(name, value);
    } else {
      return el.getAttribute(name);
    }
  }

  function addImportantStyle(ele, name, value) {
    ele.style.setProperty(name, value, "important");
  }

  function cleanStyle(ele, name) {
    ele.style.setProperty(name, "");
  }

  function addClass(ele, clsName) {
    var classes = ele.classList;
    if (!classes.contains(clsName)) {
      classes.add(clsName);
    }
  }

  function removeClass(ele, clsName) {
    var classes = ele.classList;
    if (classes.contains(clsName)) {
      classes.remove(clsName);
    }
  }

  function callNative(n, p) {
    prompt(JSON.stringify({name:n, text:p}));
  }

  function hasBkImage(ele) {
    var style = getComputedStyle(ele);
    var bkimg =style.backgroundImage;
    var bkr =style.backgroundRepeatX;
    return ("none" != bkimg) && (bkr != "repeat-x");
  }

  function shouldScale() {
    var needScale = attr(document.documentElement, "need_scale");
    if ("false" == needScale) {
        return false;
    }
    // 特殊邮件不进行缩放
    var ele = document.getElementById("mail_master_mail_content_ext");
    return !!!ele;
  }

  function doCheckQuote() {
    if (needCheckQuote) {
      needCheckQuote = false;
      checkQuote("显示引用内容", 'file:///android_asset/topic.png');
    }
  }

  var CONTENT_WIDTH = parseInt(attr(document.documentElement, "content_width")) || 360;

  function startScale() {
    doCheckQuote();
    if (!shouldScale()) {
      return;
    }
    reformator.reformattingDidFail();
    reformator.setWidth(CONTENT_WIDTH);
    reformator.reformatMessage();
    console.log(document.documentElement.innerHTML);

  }

  window.onload = function() {
    processBigAttachment();
    loadExtContent();
  }

  var contentWidth = 0;
  var waitBodyTimer = 0;
  var curKKTitleHeight = 0;
  var firstScale = true;
  function tryToResacle() {
    var times = 0;
    waitBodyTimer = setInterval(function() {
      var bodyW = document.documentElement.clientWidth;
      if ((bodyW == contentWidth) || (++times >= 5)) {
        clearInterval(waitBodyTimer);
        reScale();
      }
    }, 100)
  }

  function adjustAbsoluteTop(nodes, d) {
    for (var i = 0; i < nodes.length; ++i) {
      var node = nodes[i];
      adjustAbsoluteTop(nodes[i].children, d);
      if (node.style.position == "absolute" && node.offsetParent == document.body) {
        var t  = parseInt(node.style.top) || d;
        if (!firstLoad || t < d) {
          addClass(node, NE_CLS_CH_TOP);
          node.style.top = d + "px";
        }
      }
    }
  }
  ////Java<--->JS////
  window.adjustKKTitleBar = function(kkHeight) {
    if (undefined === kkHeight) {
      kkHeight = parseFloat(attr(document.documentElement, "kitkat_title_height")) || 0;
    }
    if (kkHeight > 0 && curKKTitleHeight != kkHeight) {
      addImportantStyle(document.documentElement, "margin-top", kkHeight + "px");
      var nodes;
      if (firstLoad) {
        nodes = document.body.children;
      } else {
        nodes = queryAll(document.body, "." + NE_CLS_CH_TOP);
      }
      adjustAbsoluteTop(nodes, kkHeight);
      firstLoad = false;
    }
  }

  function handleAllImages() {
    var imgs = queryAll(document.body, "img");
    var r = /^cid:(.*)/i
    for (var i = 0; i < imgs.length; ++i) {
      var img = imgs[i];
      var src = img.src;
      if (r.test(src)) {
        var tokens = src.match(r);
        var cid = tokens[1];
        if (cid && cid.length > 0) {
          if (!imgsMap[cid]) {
            imgsMap[cid] = [];
          }
          img.src = "file:///android_asset/bg.png?r=" + i;
          addClass(img, 'ntes-wait-for-download-img');
          imgsMap[cid].push(img);
        }
      }
    }
  }

  var delayScaleTaskCount = 0;

  function inlineOnloaded() {
    if (delayScaleTaskCount == 0) {
      delayScaleTaskCount++;
      window.setTimeout(function() {
        delayScaleTaskCount--;
        reScale();
      }, 500);
    }
  }

  function processBigAttachment() {
    var div = document.getElementById("QQMailBigAttach");
    if (!!div) {
      div.style.display="none";
    }
    div = document.getElementById("divNeteaseBigAttach");
    if (!!div) {
      div.style.display="none";
    }
  }


  window.reScale = function() {
    startScale();
    if (firstScale) {
      firstScale = false;
      // 延时100ms，防止4.4系统的title调整未完成
      setTimeout(function() {
        prompt(JSON.stringify({name:"$NE-MAIL-APP-ADJUST-DONE$"}));
      }, 100);
    }
  }

  window.setBodyPadding = function(top, bottom) {
    var scale = reformator.getDocumentScale();
    if (!!scale) {
      bottom /= scale;
    }
    addImportantStyle(document.body, "padding-bottom", bottom + "px");
  }

  window.orientationChanged = function(newContentWidth, newScreenWidth) {
    contentWidth = newContentWidth;
    CONTENT_WIDTH = newContentWidth
    clearInterval(waitBodyTimer);
    tryToResacle();
  }

  window.getText = function() {
    var bodyText = document.body.innerText;
    if (undefined === bodyText) {
      bodyText = "";
    }
    prompt(JSON.stringify({name:"$NE-MAIL-APP-SET-TEXT$", text:bodyText}));
  }
  window.showInline = function(cid, src) {
    var imgs = imgsMap[cid];
    if (imgs) {
      for (var i = 0; i < imgs.length; ++i) {
        var img = imgs[i];
        removeClass(img, 'ntes-wait-for-download-img');
        img.onload = inlineOnloaded;
        img.src = "file:///" + src;
      }
    }
  }
  ////Java<--->JS////
  adjustKKTitleBar();
  handleAllImages();
})()